package com.futhark.item;

import com.futhark.StateSaverAndLoader;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemUsageContext;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ActionResult;
import net.minecraft.util.math.BlockPos;

import static com.futhark.block.FutharkBlocks.RUNE_BLOCK;

public class RunicChiselItem extends Item {
    public RunicChiselItem(Settings settings) {
        super(settings);
    }

    @Override
    public ActionResult useOnBlock(ItemUsageContext context) {
        if (!context.getWorld().isClient()) {
            BlockPos pos = context.getBlockPos();
            PlayerEntity player = context.getPlayer();
            BlockState state = context.getWorld().getBlockState(pos);
            MinecraftServer server = context.getPlayer().getServer();

            if (state.isOf(Blocks.STONE)) {
                context.getWorld().setBlockState(pos, RUNE_BLOCK.getDefaultState());
                if (server != null) {
                    StateSaverAndLoader serverState = StateSaverAndLoader.getServerState(server);
                    serverState.totalNumberOfRunes += 1;
                }
            } else if (state.isOf(RUNE_BLOCK)) {
                context.getWorld().setBlockState(pos, Blocks.STONE.getDefaultState());
                if (server != null) {
                    StateSaverAndLoader serverState = StateSaverAndLoader.getServerState(server);
                    serverState.totalNumberOfRunes -= 1;
                }
            }
        }

        return ActionResult.SUCCESS;
    }
}
